QGIS Application - Feature request #1974
Enable render caching where possible
2009-10-05 06:10 AM - Tim Sutton

Status: Closed

Priority: Low

Assignee: Tim Sutton

Category: Map Canvas

Pull Request or Patch supplied: Resolution: fixed
Easy fix?: No Copied to github as #: 12034
Description

User story 1:

Joe is reordering layers, each of which points back to a postgis database with thousands of records. Each time he drops a layer to a new
position, he waits a long time while each layer redraws, even though the content of the layers is the same, just being rendered in a
different order.

User story 2:

Jane is changing symbology in a layer. When she clicks apply, she waits a long time while all other layers redraw too.

User story 3:

Pete is hiding and showing layers. Each time he hides or shows a layer, he waits a long time while the layers redraw.

The solution to this is to provide some kind of caching mechanism. The attached patch is my first draft that addresses the above
scenarios and makes QGIS much more responsive when engaged in the activities described.

Please note the patch is a work in progress and there are some edge cases where it does not yet behave well. In order to activate
caching, tick the checkbox for this in the rendering tab of the options panel (its disabled by default).

History

#1 - 2009-10-22 02:44 PM - Tim Sutton

Version 5 offers dramatically better performance now that | have changed it to use QImage rather than QPixmap. The last remaining task is to clear the

cache images of non-visible layers when the extents change to prevent rendering anomalies when enabling display of a layer after a zoom operation.

#2 - 2009-10-22 02:44 PM - Tim Sutton

- Status changed from Open to In Progress

#3 - 2009-10-23 03:22 PM - Tim Sutton

Version 6 of the patch is now quite usable and deals well with most issues | think. | will propose this patch for inclusion into trunk.

#4 - 2009-10-24 06:31 AM - Tim Sutton

- Resolution set to fixed

- Status changed from In Progress to Closed
This patch is applied to trunk as of commit:763fbb20 (SVN r11832).

Files

qgis_render_cache_v3.diff
qgis_rendercachepatch_v4_210ct2009.diff.gz
qgis_rendercachepatch_v5_220c¢t2009.diff
qgis_rendercachepatch_v6_230ct2009.diff
qgis_rendercachepatch_v7_230ct2009.diff
qgis_rendercachepatch_v8240ct2009.diff
